#version 400 core

in vec2 fragmentUV;

out vec4 color;

uniform sampler2D originalTexture;

uniform sampler2D depthTexture;
uniform sampler2D blurTexture;
uniform float actualLife;
uniform float totalLife;

//uniform float zNear;
//uniform float zFar;

float LinearizeDepth(float z)
{
float zNear = 0.1f;
float zFar = 100.0f;
  return (2.0 * zNear) / (zFar + zNear - z * (zFar - zNear));
  
  
  //return -zFar * zNear / (z * (zFar - zNear) - zFar);
}

void main() {
	
	vec4 org = texture(originalTexture, fragmentUV);
	vec4 blur = texture(blurTexture, fragmentUV);
	
	float z = LinearizeDepth(texture(depthTexture, fragmentUV).x);
	float focus = 0.25;
	float t = abs(z - focus)/max(focus, focus);
	
	float r = 1 - t;
	float life = actualLife / totalLife;
	
	//color = vec4(z, z, z, 1.0);
	
	color = r * org + t * blur;
	
	//color = r * org * life + t * (1 - org);
	//color = blur;
	//color = org;
}
