#version 400 core

in vec2 fragmentUV;
out vec4 color;

uniform sampler2D sceneTexture;
uniform float offset[3];
uniform float gaussian[3];
uniform int vertical;
uniform float width;
uniform float height;

void main() {
	vec4 sum = vec4(0.0);
	vec2 point = vec2(fragmentUV.x, fragmentUV.y);
	//vec2 point = vec2(gl_FragCoord);
	
	
	sum += texture(sceneTexture, (point)) * gaussian[0];
	if(vertical == 1) {
	
		sum += texture(sceneTexture, (point + vec2(offset[2], 0)/width)) * gaussian[2];
		sum += texture(sceneTexture, (point + vec2(offset[1], 0)/width)) * gaussian[1];
		sum += texture(sceneTexture, (point - vec2(offset[1], 0)/width)) * gaussian[1];
		sum += texture(sceneTexture, (point - vec2(offset[2], 0)/width)) * gaussian[2];
	
	
		/*
		sum += texture(sceneTexture, (point)) * gaussian[0];
		for(int i = 1; i < 3; i++) {
			sum += texture(sceneTexture, (point + vec2(offset[i], 0)/width)) * gaussian[i];
			sum += texture(sceneTexture, (point - vec2(offset[i], 0)/width)) * gaussian[i];
		}*/
		/*
		sum += texture(sceneTexture, (point + vec2(-2 , 0))/640.0) * gaussian[2];
		sum += texture(sceneTexture, (point + vec2(-1 , 0))/640.0) * gaussian[1];
		sum += texture(sceneTexture, point/640.0) * gaussian[0];
		sum += texture(sceneTexture, (point + vec2(1 , 0))/640.0) * gaussian[1];
		sum += texture(sceneTexture, (point + vec2(2 , 0))/640.0) * gaussian[2];*/
		/*
		sum += texture(sceneTexture, (point + vec2(-2 , 0)/640.0)) * gaussian[2];
		sum += texture(sceneTexture, (point + vec2(-1 , 0)/640.0)) * gaussian[1];
		sum += texture(sceneTexture, point) * gaussian[0];
		sum += texture(sceneTexture, (point + vec2(1 , 0)/640.0)) * gaussian[1];
		sum += texture(sceneTexture, (point + vec2(2 , 0)/640.0)) * gaussian[2];*/
		
	}
	if(vertical == 0) {
		sum += texture(sceneTexture, (point + vec2(0, offset[2]))/height) * gaussian[2];
		sum += texture(sceneTexture, (point + vec2(0, offset[1]))/height) * gaussian[1];
		sum += texture(sceneTexture, (point - vec2(0, offset[1]))/height) * gaussian[1];
		sum += texture(sceneTexture, (point - vec2(0, offset[2]))/height) * gaussian[2];
		
		 /*sum += texture(sceneTexture, (point)/height) * gaussian[0];
		for(int i = 1; i < 3; i++) {
			sum += texture(sceneTexture, (point + vec2(0, offset[i]))/height) * gaussian[i];
			sum += texture(sceneTexture, (point - vec2(0, offset[i]))/height) * gaussian[i];
		}*/
		/*
		sum += texture(sceneTexture, (point + vec2(0, -2))/480) * gaussian[2];
		sum += texture(sceneTexture, (point + vec2(0, -1))/480) * gaussian[1];
		sum += texture(sceneTexture, point/480) * gaussian[0];
		sum += texture(sceneTexture, (point + vec2(0, 1))/480) * gaussian[1];
		sum += texture(sceneTexture, (point + vec2(0, 2))/480) * gaussian[2];
		*/
	}
	
	//color = texture(sceneTexture, fragmentUV);
	color = sum;
	//color = 1 - texture(colorTexture, point + vec2(2 , 0) * (1.0 / 300.0));
}