#version 400 core

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 uv;
layout (location = 3) in mat4 model;

out FRAG_VALUES {
	vec2 FragmentUV;
	vec3 Position;
	vec3 Normal;
	vec3 View;
}vert_out;

struct Light {
	vec3 position;
	vec3 ambColor;
	float constant;
	float linear;
	float quadratic;
};

uniform Light light;
//uniform mat4 projectionViewModel;
uniform mat4 transformation;
uniform mat4 view;
uniform mat4 projection;

uniform vec4 plane;

void main() {
	vert_out.FragmentUV = uv;
	vert_out.Normal = normalize(vec3(transpose(inverse(view * model)) * vec4(normal,0)));
	vert_out.Position = vec3(view * model * vec4(position, 1));
	vert_out.View = normalize(-vert_out.Position);

	vec4 worldPos = model * vec4(position, 1);
	gl_ClipDistance[0] = dot(worldPos,plane);	

	gl_Position = projection * view * model * transformation * vec4(position, 1);
}